<?php

namespace KERN23\ContentDesigner\Utility;

class TypoScript {

    // Lädt die Typoscript konfiguration für das plugin / extension
	public static function loadConfig(&$config, $prefixId, $pageUid = 0) {
		$arr_list = self::loadTS($config,$pageUid);
		if ( !is_array($arr_list) || (sizeof($arr_list) <= 0) || !is_array($arr_list['tt_content.']) ) return $config;
		
		foreach ( array_keys($arr_list['tt_content.']) as $key ) {
			if ( preg_match("/^".$prefixId."_(.*)\.$/i",$key,$match) ) {
				$retAr[$key] = $arr_list['tt_content.'][$key];
			}
		}
		
		return $retAr;
	}

	// Load the TypoScript Conf Array in the Backend
	public static function loadTS(&$conf, $pageUid = 0) {
		unset($pid);
		
		// Try to get the current page id to load the TS Setup from it
		if ( intval($pageUid) > 0 ) 				$pid = intval($pageUid);
		if ( empty($pid) && (intval($conf['row']['pid']) > 0) ) $pid = intval($conf['row']['pid']);
		if ( empty($pid) && ($_GET['returnUrl']) ) 		$pid = intval(preg_replace("/^.*id=([0-9]{1,}).*$/i","$1",$_GET['returnUrl'],1));
		if ( empty($pid) && isset($_GET['id']) ) 		$pid = intval($_GET['id']);
		if ( empty($pid) && isset($_GET['edit']) && is_array($_GET['edit']) ) {
			$table = key($_GET['edit']);
			$UIDs   = array_keys($_GET['edit'][$table]);
			$ce = \TYPO3\CMS\Backend\Utility\BackendUtility::getRecord($table, (int)$UIDs[0], 'pid');
			$pid = $ce['pid'];
		}
		if ( empty($pid) ) return false;
		
		$ps = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('t3lib_pageSelect');
		$rootline = $ps->getRootLine($pid);
		if (empty($rootline)) return false;
		
		$tsObj = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('t3lib_tsparser_ext');
		$tsObj->tt_track = 0;
		$tsObj->init();
		$tsObj->runThroughTemplates($rootline);
		$tsObj->generateConfig();
		
		return $tsObj->setup;
	}
	
	// Inits the cObject for the Backend
	public static function cObjInit() {
		$pid = (int)$_GET['id'];
		$GLOBALS['TSFE'] = new \TYPO3\CMS\Frontend\Controller\TypoScriptFrontendController($TYPO3_CONF_VARS, $pid, 0, true);
		return \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Frontend\\ContentObject\\ContentObjectRenderer');
	}
	
	// Parsed TypoScript Objekte
	public static function parseTypoScriptObj($objType,$objArray,$cObj) {
		if ( (!empty($objType)) && (sizeof($objArray) > 0) ) {
			return $cObj->cObjGetSingle($objType,$objArray);
		} else return false;
	}
}

?>